%global _internal_version  f9e5c51
%define date 20170106
# .so name pulls in a lot of devel packages
%global __requires_exclude_from ^%{_libdir}/.*\\.so$

Name:           cinnamon
Version:        3.2.8
Release:        %mkrel 2
#Release:        %mkrel 0.%{date}.git%{_internal_version}
Summary:        Window management and application launching for Cinnamon

Group:          Graphical desktop/Cinnamon
# cinnamon-menu-editor is LGPLv2+
License:        GPLv2+ and LGPLv2+
URL:            http://cinnamon.linuxmint.com
# To generate tarball

Source0:        %{name}-%{version}.tar.gz
#SourceGet0: https://github.com/linuxmint/Cinnamon/archive/%{version}.tar.gz

#Source0:        %{name}-%{version}.git%{_internal_version}.tar.gz
##SourceGet0: https://github.com/linuxmint/Cinnamon/tarball/%{_internal_version}
Source1:        cinnamon-mageia.gschema.override
Source3:        polkit-cinnamon-authentication-agent-1.desktop
# fix power applet using version by robin92
# https://github.com/linuxmint/Cinnamon/issues/3068
#Source7:        power-applet.js
Source4:        mageia-menu.svg

# from fedora
Patch0:         background.patch
Patch1:         autostart.patch
Patch2:         default_panal_launcher.patch

%global clutter_version 1.12.2
%global gobject_introspection_version 0.10.1
%global muffin_version 2.6.2
%global eds_version 2.91.6
%global json_glib_version 0.13.2
%global polkit_version 0.100

BuildRequires:  pkgconfig(clutter-x11-1.0) >= %{clutter_version}
BuildRequires:  pkgconfig(dbus-glib-1)
BuildRequires:  desktop-file-utils
BuildRequires:  glib2-devel
BuildRequires:  pkgconfig(gconf-2.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires:  pkgconfig(libnm-glib)
BuildRequires:  pkgconfig(libnm-util)
BuildRequires:  pkgconfig(polkit-agent-1) >= %{polkit_version}
BuildRequires:  libgudev-devel
# for screencast recorder functionality
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gtk+-3.0)
BuildRequires:  intltool
BuildRequires:  pkgconfig(libcanberra)
BuildRequires:  pkgconfig(libcroco-0.6) >= 0.6.2
BuildRequires:  pkgconfig(gnome-keyring-1)
BuildRequires:  pkgconfig(libsoup-2.4)
BuildRequires:  pkgconfig(libnm-glib-vpn)
BuildRequires:  pkgconfig(libstartup-notification-1.0)

# for barriers
BuildRequires:  pkgconfig(xfixes) >= 5.0
# used in unused BigThemeImage
BuildRequires:  librsvg2-devel
BuildRequires:  pkgconfig(libmuffin) >= %{muffin_version}
BuildRequires:  libpulseaudio-devel
# Bootstrap requirements
BuildRequires: gtk-doc 
BuildRequires: gnome-common
%ifnarch %{arm}
BuildRequires:  pkgconfig(libwacom)
BuildRequires:  pkgconfig(xorg-wacom)
%endif
BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(gdk-x11-3.0)
BuildRequires:  pkgconfig(cjs-internals-1.0)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(cinnamon-desktop) >= 2.0.4
BuildRequires:  pkgconfig(libcinnamon-menu-3.0)

#required for applet fix
BuildRequires:  patchelf
BuildRequires:  chrpath

Requires:       cinnamon-menus
# wrapper script uses to restart old GNOME session if run --replace
# from the command line
Requires:       gobject-introspection >= %{gobject_introspection_version}
# needed for loading SVG's via gdk-pixbuf
#Requires:       librsvg2%{?_isa}
# needed as it is now split from Clutter
Requires:       json-glib >= %{json_glib_version}
# might be still be needed.
Requires:       muffin >= %{muffin_version}
# Get upower 1.0 api changes
Requires:       upower >= 0.99.0
Requires:       polkit >= 0.100
# needed for session files
# cinnamon-session version fixes location of helper app
Requires:       cinnamon-session
# needed for schemas
Requires:       at-spi2-atk
# needed for on-screen keyboard
Requires:       caribou
# needed for settings
Requires:       python-gobject
Requires:       python-gobject-cairo
Requires:       dbus-python
Requires:       python-lxml
Requires:       gnome-python-gconf
Requires:       python-imaging
Requires:       python-pam
Requires:       python-pexpect
Requires:       python-pillow
Requires:       cinnamon-control-center
Requires:       cinnamon-screensaver
Requires:       cinnamon-translations
# fix 10916
Requires:       gnome-themes-standard
# fix cinnamon startup crashes
#Requires:       typelib(fontconfig)
# include cjs introspection
Requires:       cjs
# Mate polkit
Requires:       mate-polkit
# requires for keyboard applet
Requires:       gucharmap

# required for network applet
Requires:       networkmanager
#needed for cinnamon-looking-glass
Requires:       python-pyinotify
#needed for cinnamon-json-makepot
Requires:       python-polib
# needed for user and groups and things that need root
# see bug 17691
Requires:       gksu

#otherwise crashed at login
Requires:       nemo

# cinnamon handles notifications natively, no notification-daemon needed
Provides:       virtual-notification-daemon
# and ditto for polkit authorisation dialogs
Provides:       polkit-agent

#force requires to deal with mutter confusion

Requires:  %{mklibname clutter-gir 1.0}
Requires:  %{mklibname cogl-pango-gir 1.0}
Requires:  %{mklibname cogl-gir 1.0}

%description
Cinnamon is a Linux desktop which provides advanced
 innovative features and a traditional user experience.

The desktop layout is similar to Gnome 2. 
The underlying technology is forked from Gnome Shell.
The emphasis is put on making users feel at home and providing
 them with an easy to use and comfortable desktop experience.

%package   devel-doc
Summary:   Development Documentation files for Cinnamon
BuildArch: noarch
Requires:  %{name} = %{version}-%{release}

%description	   devel-doc
This package contains the code documentation for various Cinnamon components.

%prep
%setup -q
#autosetup -p1 -n linuxmint-Cinnamon-%{_internal_version}

# remove gschema
rm -rf data/org.cinnamon.gschema.xml

# have cinnamon use mageia app system
grep -r -l cinnamon-applications.menu files%{_datadir} files%{_bindir}  src | \
xargs sed -i -e 's@cinnamon-applications@applications@g' 

# files replaced with mageia files
rm -rf files%{_sysconfdir}/xdg
rm -f files%{_datadir}/desktop-directories/cinnamon-{menu-applications,utility,utility-accessibility,development,education,game,graphics,network,audio-video,office,system-tools,other}.directory

# replace icon 
sed -i ./files/usr/share/cinnamon/applets/menu@cinnamon.org/settings-schema.json -e s@menu-symbolic.svg@mageia-menu.svg@g
sed -i ./files/usr/share/cinnamon/applets/menu@cinnamon.org/applet.js -e s@menu-symbolic.svg@mageia-menu.svg@g

rm -f configure
rm -rf debian/

NOCONFIGURE=1 ./autogen.sh

%build
%configure2_5x \
 --disable-static \
 --disable-rpath \
 --disable-schemas-compile \
 --enable-introspection=yes \
 --enable-compile-warnings=no

sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool

%make V=1

%install
%makeinstall_std
find %{buildroot} -type f -name "*.la" -delete -print

install -D -m 0644 %{SOURCE1} %{buildroot}%{_datadir}/glib-2.0/schemas/cinnamon-mageia.gschema.override

# install polkik autostart desktop file
install -D -p -m 0644 %{SOURCE3} %{buildroot}%{_datadir}/applications/
install -D -p -m 0644 %{SOURCE4} %{buildroot}%{_datadir}/cinnamon/theme

desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon2d.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-killer-daemon.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-settings*.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-menu-editor.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/polkit-cinnamon-authentication-agent-1.desktop

desktop-file-install                                 \
 --add-category="Utility"                            \
 --remove-category="DesktopSettings"                 \
 --remove-key="Encoding"                             \
 --add-only-show-in="GNOME"                          \
 --delete-original                                   \
 --dir=%{buildroot}%{_datadir}/applications       \
 %{buildroot}%{_datadir}/applications/*

# fix path for CinnamonJS
ln -s cinnamon/libcinnamon-js.so %{buildroot}%{_libdir}

# fix hard coded paths
%ifarch x86_64 ppc64
sed -i -e 's@/usr/lib/cinnamon-control-center@/usr/lib64/cinnamon-control-center@g' \
$RPM_BUILD_ROOT/%{_prefix}/share/cinnamon/cinnamon-settings/bin/capi.py
%endif

# delete the preload bits till it supports systemd
rm -f $RPM_BUILD_ROOT/%{_bindir}/cinnamon-preload*
rm -rf $RPM_BUILD_ROOT/%{_sysconfdir}/cinnamon/

%posttrans
if [ "$1" -eq 1 ]; then
	if [ -e %{_datadir}/xsessions/10Cinnamon.desktop ]; then
		rm -rf %{_datadir}/xsessions/10Cinnamon.desktop
	fi
	if [ -e %{_datadir}/xsessions/11Cinnamon2D.desktop ]; then
		rm -rf %{_datadir}/xsessions/11Cinnamon2D.desktop
	fi
fi

%files
%doc COPYING README AUTHORS
%{_bindir}/*
%{_datadir}/desktop-directories/cinnamon-*.directory
%{_datadir}/glib-2.0/schemas/*
%{_datadir}/applications/*
%{_datadir}/icons/hicolor/*/*/bluetooth.svg
%{_datadir}/icons/hicolor/*/*/cs-*.svg
%{_datadir}/icons/hicolor/*/*/pan-*.svg
%{_datadir}/icons/hicolor/*/*/audio-*.svg
%{_datadir}/icons/hicolor/*/*/*-lock-*.svg
%{_datadir}/icons/hicolor/*/*/cpu-*.svg
%{_datadir}/icons/hicolor/*/*/cinnamon-panel-launcher.svg
%{_datadir}/polkit-1/actions/org.cinnamon.settings-users.policy
%{_datadir}/cinnamon/
%{_datadir}/cinnamon-*/
%{_datadir}/dbus-1/services/org.Cinnamon.*.service
%{_datadir}/xsessions/*
%{_libdir}/cinnamon/
%{_libdir}/libcinnamon-js.so
%{_libexecdir}/cinnamon/
%{_mandir}/man1/*.1.*

%files devel-doc
%doc %{_datadir}/gtk-doc/html/*/


%changelog
* Mon Jul 10 2017 adrianomorselli <adrianomorselli> 3.2.8-2uplos2017
- update and fix requires
